# Les dimensions sont en millimetres

Zf = 3.0

X0 = 7
Y0 = 7

DeltaX = 12
DeltaY = 12

Xstart = X0
Ystart = Y0

# Parametre carre
dlaser = 0.25
cote = 10

gcode = "G90\nG92 X0 Y0 Z0\nG21\nG0 Z" + str(round(Zf,2)) + " F5000\n\n(calque : raster) \n"


def carre(power, speed, Xstart, Ystart):
    nbligne = int(cote / dlaser)
    
    Xend = Xstart + cote - dlaser / 2
    Xstart += dlaser / 2
    Ystart += dlaser / 2
    
    fpower = power / 100.0
    
    print ('power : ', power, ' fpower : ', fpower)
    
    X = Xstart
    Y = Ystart + dlaser / 2
    
    gcodec = "(motif " + str(power) + " / " + str(speed) + ")\n"
    gcodec += "G00 X" + str(round(Xstart, 3)) + " Y" + str(round(Ystart, 3)) + "\n"
    
    for ligne in range(nbligne):
        #print('ligne : ', ligne)
        if (X == Xstart) :
            X = Xend
        else:
            X = Xstart
        gcodec += "G01 X" + str(round(X, 3)) + " F" + str(speed) + " S" + str(fpower) + "\n"
        Y += dlaser
        gcodec += "G01 Y" + str(round(Y, 3))  + " F" + str(speed) + " S" + str(fpower) + "\n"
        #gcodec += "G00 Y" + str(round(Y, 3)) + "\n"
    return gcodec


for power in range(20, 110, 10):
    #print('power : ', power)
    Xstart = X0
    for speed in range(3500, 9750, 500):
        #print(' speed : ', speed)
        #print(' Xstart : ', Xstart, ' Ystart : ', Ystart)
        gcode += carre(power, speed, Xstart, Ystart)
        Xstart += DeltaX
    Ystart += DeltaY
gcode += "\n"

file = open("Fin.gcode","r")
gcodefin = file.read()
file.close()

file = open("grille_raster-Z3-F3500-9500-continu2.gcode","w")
file.write(gcode)
file.write(gcodefin)
file.close()
